;;; Generated by Guile-SMC 0.6.3
;;; <https://github.com/artyom-poptsov/guile-smc>


;;; This finite-state machine is produced by:
;;;   PlantUML <https://plantuml.com> Reader Finite-State Machine.
;;;   This FSM is a part of Guile State-Machine Compiler (Guile-SMC)
;;;   <https://github.com/artyom-poptsov/guile-smc>
;;;
;;; Statistics:
;;;   step-counter:              4034
;;;   transition-counter:         451
;;;
;;; Resolver status:
;;;   #<directory (dsv fsm context)>
;;;     #<procedure #{guard:#t}# (ctx event)>
;;;     #<procedure action:no-op (ctx event)>
;;;     #<procedure char:cr? (ctx ch2)>
;;;     #<procedure char:double-quote? (ctx ch2)>
;;;     #<procedure char:eof-object? (ctx ch)>
;;;     #<procedure char:lf? (ctx ch2)>
;;;     #<procedure next-char (context)>
;;;     #<procedure push-event-to-buffer (context event)>
;;;     #<procedure stanza-empty? (context #:optional event)>
;;;     #<procedure throw-syntax-error (context char)>
;;;   #<directory (dsv fsm dsv-context)>
;;;     #<procedure add-field args>
;;;     #<procedure add-non-empty-field args>
;;;     #<procedure add-row args>
;;;     #<procedure delimiter? (a b)>
;;;     #<procedure none (a)>
;;;     #<procedure prepare-result args>
;;;   #<directory (smc puml)>
;;;     #<<generic> char-context-event-source (1)>


(define-module
  (dsv fsm rfc4180)
  #:use-module
  (oop goops)
  #:use-module
  (smc fsm)
  #:use-module
  (dsv fsm context)
  #:use-module
  (dsv fsm dsv-context)
  #:re-export
  (fsm-run!)
  #:export
  (<rfc4180-fsm>))



(define %transition-table
  `(((name . read_lf)
     (description . "Read the line feed symbol.")
     (event-source unquote next-char)
     (transitions
       (,char:eof-object? ,throw-syntax-error #f)
       (,char:lf? ,add-field add_row)
       (,#{guard:#t}# ,throw-syntax-error #f)))
    ((name . add_row)
     (description . "Add a row to the data.")
     (event-source unquote none)
     (entry-action unquote add-row)
     (transitions
       (,#{guard:#t}#
        ,action:no-op
        read_field_first_char)))
    ((name . read_field_first_char)
     (description
       .
       "Read the first character in a field.")
     (event-source unquote next-char)
     (transitions
       (,char:eof-object? ,action:no-op add_final_row)
       (,char:double-quote?
        ,action:no-op
        read_quoted_field)
       (,delimiter? ,add-field read_field_first_char)
       (,char:cr? ,action:no-op read_lf)
       (,#{guard:#t}# ,push-event-to-buffer read_field)))
    ((name . read_field)
     (description . "Read the first field in a row.")
     (event-source unquote next-char)
     (transitions
       (,char:eof-object?
        ,add-non-empty-field
        add_final_row)
       (,delimiter? ,add-field read_field_first_char)
       (,char:cr? ,action:no-op read_lf)
       (,char:lf? ,add-field add_row)
       (,char:double-quote? ,throw-syntax-error #f)
       (,#{guard:#t}# ,push-event-to-buffer read_field)))
    ((name . read_first_field_first_char)
     (description
       .
       "Read the first character in the first field.")
     (event-source unquote next-char)
     (transitions
       (,char:eof-object? ,action:no-op #f)
       (,char:double-quote?
        ,action:no-op
        read_quoted_field)
       (,delimiter? ,add-field read_field_first_char)
       (,char:cr? ,throw-syntax-error #f)
       (,#{guard:#t}# ,push-event-to-buffer read_field)))
    ((name . read_quote)
     (description
       .
       "Read the next symbol after a quote in a quoted field.")
     (event-source unquote next-char)
     (transitions
       (,char:eof-object? ,add-field add_final_row)
       (,char:cr? ,action:no-op read_lf)
       (,char:lf? ,add-field add_row)
       (,char:double-quote?
        ,push-event-to-buffer
        read_quoted_field)
       (,delimiter? ,add-field read_field_first_char)
       (,#{guard:#t}# ,throw-syntax-error #f)))
    ((name . read_quoted_field)
     (description . "Read a quoted field.")
     (event-source unquote next-char)
     (transitions
       (,char:eof-object? ,throw-syntax-error #f)
       (,char:double-quote? ,action:no-op read_quote)
       (,#{guard:#t}#
        ,push-event-to-buffer
        read_quoted_field)))
    ((name . add_final_row)
     (description . "Add a final row to the data.")
     (event-source unquote none)
     (exit-action unquote prepare-result)
     (transitions
       (,stanza-empty? ,action:no-op #f)
       (,#{guard:#t}# ,add-row #f)))))


(define-class <rfc4180-fsm> (<fsm>))


(define-method
  (initialize (self <rfc4180-fsm>) initargs)
  (next-method)
  (fsm-description-set!
    self
    "RFC4180-style DSV parser.")
  (fsm-event-source-set! self next-char)
  (fsm-transition-table-set!
    self
    (transition-list->hash-table
      self
      %transition-table))
  (fsm-current-state-set!
    self
    (fsm-state self 'read_first_field_first_char)))

