;;; Generated by Guile-SMC 0.6.3
;;; <https://github.com/artyom-poptsov/guile-smc>


;;; This finite-state machine is produced by:
;;;   PlantUML <https://plantuml.com> Reader Finite-State Machine.
;;;   This FSM is a part of Guile State-Machine Compiler (Guile-SMC)
;;;   <https://github.com/artyom-poptsov/guile-smc>
;;;
;;; Statistics:
;;;   step-counter:              2930
;;;   transition-counter:         333
;;;
;;; Resolver status:
;;;   #<directory (dsv fsm context)>
;;;     #<procedure #{guard:#t}# (ctx event)>
;;;     #<procedure action:no-op (ctx event)>
;;;     #<procedure char:eof-object? (ctx ch)>
;;;     #<procedure char:newline? (ctx ch2)>
;;;     #<procedure char:reverse-solidus? (ctx ch2)>
;;;     #<procedure next-char (context)>
;;;     #<procedure push-event-to-buffer (context event)>
;;;     #<procedure stanza-empty? (context #:optional event)>
;;;     #<procedure throw-syntax-error (context char)>
;;;   #<directory (dsv fsm dsv-context)>
;;;     #<procedure add-field args>
;;;     #<procedure add-non-empty-field args>
;;;     #<procedure add-row args>
;;;     #<procedure comment-prefix? (a b)>
;;;     #<procedure delimiter? (a b)>
;;;     #<procedure end-of-row? (a b)>
;;;     #<procedure non-printable-character? (a b)>
;;;     #<procedure none (a)>
;;;     #<procedure prepare-result args>
;;;     #<procedure push-non-printable-character (a b)>
;;;   #<directory (smc puml)>
;;;     #<<generic> char-context-event-source (1)>


(define-module
  (dsv fsm unix)
  #:use-module
  (oop goops)
  #:use-module
  (smc fsm)
  #:use-module
  (dsv fsm context)
  #:use-module
  (dsv fsm dsv-context)
  #:re-export
  (fsm-run!)
  #:export
  (<unix-fsm>))



(define %transition-table
  `(((name . read_first_field)
     (description . "Read the first field in a row.")
     (event-source unquote next-char)
     (transitions
       (,char:eof-object?
        ,add-non-empty-field
        add_final_row)
       (,comment-prefix? ,action:no-op skip_comment)
       (,end-of-row? ,add-field add_row)
       (,delimiter? ,add-field read_field)
       (,char:reverse-solidus?
        ,action:no-op
        read_escaped_char_in_first_field)
       (,#{guard:#t}#
        ,push-event-to-buffer
        read_first_field)))
    ((name . add_row)
     (description . "Add a row to the data.")
     (event-source unquote none)
     (entry-action unquote add-row)
     (transitions
       (,#{guard:#t}# ,action:no-op read_first_field)))
    ((name . skip_comment)
     (event-source unquote next-char)
     (transitions
       (,char:eof-object? ,prepare-result #f)
       (,end-of-row? ,action:no-op read_first_field)
       (,#{guard:#t}# ,action:no-op skip_comment)))
    ((name . read_field)
     (description
       .
       "Read the rest of fields in a row.")
     (event-source unquote next-char)
     (transitions
       (,char:eof-object? ,add-field add_final_row)
       (,comment-prefix? ,action:no-op skip_comment)
       (,end-of-row? ,add-field add_row)
       (,delimiter? ,add-field read_field)
       (,char:reverse-solidus?
        ,action:no-op
        read_escaped_char_in_field)
       (,#{guard:#t}# ,push-event-to-buffer read_field)))
    ((name . read_escaped_char_in_field)
     (event-source unquote next-char)
     (transitions
       (,char:eof-object? ,throw-syntax-error #f)
       (,non-printable-character?
        ,push-non-printable-character
        read_field)
       (,#{guard:#t}# ,push-event-to-buffer read_field)))
    ((name . read_escaped_char_in_first_field)
     (event-source unquote next-char)
     (transitions
       (,char:eof-object? ,throw-syntax-error #f)
       (,non-printable-character?
        ,push-non-printable-character
        read_first_field)
       (,char:newline? ,action:no-op read_first_field)
       (,#{guard:#t}#
        ,push-event-to-buffer
        read_first_field)))
    ((name . add_final_row)
     (description . "Add a final row to the data.")
     (event-source unquote none)
     (exit-action unquote prepare-result)
     (transitions
       (,stanza-empty? ,action:no-op #f)
       (,#{guard:#t}# ,add-row #f)))))


(define-class <unix-fsm> (<fsm>))


(define-method
  (initialize (self <unix-fsm>) initargs)
  (next-method)
  (fsm-description-set!
    self
    "Unix-style DSV parser.")
  (fsm-event-source-set! self next-char)
  (fsm-transition-table-set!
    self
    (transition-list->hash-table
      self
      %transition-table))
  (fsm-current-state-set!
    self
    (fsm-state self 'read_first_field)))

